import { globalLookup } from "@/hook/global";
import { recoverFromJson, recoverSession } from "@/hook/recover";
import { ElLoading } from "element-plus";
import i18n from "@/i18n/index";

const { t } = i18n.global;

/**
 * 
 * @param {MessageEvent} event 
 */
export function handleVscodeMessage(event) {
    const command = event.data.command;
    switch (command) {
        case 'save-view-as':
            saveViewAs(event.data);
            break;
        case 'load-view':
            loadView(event.data);
            break;
        default:
            break;
    }
}

function loadView(data) {
    const { recoverJson, viewPath } = data;
    if (recoverJson === undefined || viewPath === undefined) {
        return;
    }
    const loading = new ElLoading.service({
        lock: true,
        text: t('loading'),
        background: 'rgba(0, 0, 0, 0.7)'
    });
    globalLookup.originVcdViewFile = viewPath;
    recoverFromJson(recoverJson);
    recoverSession(globalLookup.topModules);
    loading.close();
}

function saveViewAs(data) {
    const { viewPath } = data;
    if (viewPath === undefined) {
        return;
    }
    globalLookup.originVcdViewFile = viewPath;
}