// 触控事件


const platform = navigator.platform;
const touchState = {
    startX: undefined,
    startY: undefined
};


// TODO: 完成这个 和 手势控制

/**
 * 
 * @param {WaveElements} element 
 * @param {Pstate} pstate 
 * @param {Deso} deso 
 * @param {Record<string, Handler>} eventHandler 
 * @param {TouchEvent} event 
 */
function macTouchmove(element, pstate, deso, eventHandler, event) {
    const touch = event.touches[0];
    if (touch) {
        const { pageX, pageY } = touch;
        const deltaX = pageX - touchState.startX;
        const deltaY = pageY - touchState.startY;

        const updownKey = (deltaY < 0) ? 'scrollDown' : 'scrollUp';
        const leftrightKey = (deltaX < 0) ? 'scrollRight' : 'scrollLeft';
        
        eventHandler[updownKey].fn(pstate);
        deso.render();

        // eventHandler[leftrightKey].fn(pstate);
        // deso.render();
    }
    event.preventDefault();
}


/**
 * 
 * @param {WaveElements} element 
 * @param {Pstate} pstate 
 * @param {Deso} deso 
 * @param {Record<string, Handler>} eventHandler 
 * @param {TouchEvent} event 
 */
function macTouchstart(element, pstate, deso, eventHandler, event) {
    const touch = event.touches[0];
    if (touch) {
        const { pageX, pageY } = touch;
        touchState.startX = pageX;
        touchState.startY = pageY;
    }
    event.preventDefault();
}

/**
 * 
 * @param {WaveElements} element 
 * @param {Pstate} pstate 
 * @param {Deso} deso 
 * @param {Record<string, Handler>} eventHandler 
 * @param {TouchEvent} event 
 */
function macTouchend(element, pstate, deso, eventHandler, event) {
    touchState.startX = undefined;
    touchState.startY = undefined;
    event.preventDefault();
}


/**
 * 
 * @param {WaveElements} element 
 * @param {Pstate} pstate 
 * @param {Deso} deso 
 * @param {Record<string, Handler>} eventHandler 
 * @returns {(event: TouchEvent) => void}
 */
function registerTouchmoveEvent(element, pstate, deso, eventHandler) {
    if (platform.startsWith('Mac')) {
        // IOS
        return event => macTouchmove(element, pstate, deso, eventHandler, event);
    } else {
        return event => {}
    }
}

/**
 * 
 * @param {WaveElements} element 
 * @param {Pstate} pstate 
 * @param {Deso} deso 
 * @param {Record<string, Handler>} eventHandler 
 * @returns {(event: TouchEvent) => void}
 */
function registerTouchstartEvent(element, pstate, deso, eventHandler) {
    if (platform.startsWith('Mac')) {
        return event => macTouchstart(element, pstate, deso, eventHandler, event);
    } else {
        return event => {}
    }
}

/**
 * 
 * @param {WaveElements} element 
 * @param {Pstate} pstate 
 * @param {Deso} deso 
 * @param {Record<string, Handler>} eventHandler 
 * @returns {(event: TouchEvent) => void}
 */
function registerTouchendEvent(element, pstate, deso, eventHandler) {
    if (platform.startsWith('Mac')) {
        return event => macTouchend(element, pstate, deso, eventHandler, event);
    } else {
        return event => {}
    }
}

export {
    registerTouchstartEvent,
    registerTouchmoveEvent,
    registerTouchendEvent
};